//---------------------------------------------------------------------------
// JrDebug demo that can be used to test how well jrdebug "compiles-out"
//  ie this can be used to see the difference between code with no debugging
//  statements, and code with debugging statements but built in release mode
//  with jrdebug told not to compile in debug info.
// ideally one wants 0 impact on exe size and cpu usage when jrdebug is
//  compiled out.
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// System includes
#include <iostream>
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// compile once with this set, and once without, and compare; if you dont
//  comment out this symbol, then it will test result of code where debug
//  statements were never added (ie clean code), and with the symbol it
//  will test code with debug statements, but with compile-out flag.
//  ideally these should result in identical resulting applications.
// #define NotUsingJrDebugSystem
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
#ifndef NotUsingJrDebugSystem
 // force jrdebug to include but not compile in; this simulates normal
 //  case of building a release build
 #define JrDebugDIRECTIVE_DontCompileDebugging
 //
 // Include the Debugging Library files
 //  Note that only our main .cpp needs to include the jrdebug_main.cpp file
 //  alternatively, you could add this cpp to your project or makefile.
 #include "../../jrdebug_main.cpp"
#endif
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
int main(int argc, char *argv[])
{
	// common start of a jrdebug using program
    #ifndef NotUsingJrDebugSystem
		// automatically parse commandline options and exit if appropriate
		if (JrDebugParseCommandlineArgc("Demo10",&argc,argv,"-db"))
			return 0;
	#endif

	// announce
    #ifndef NotUsingJrDebugSystem
	  printf("Inside main() of program ... using JrDebug.\n");
    #else
	  printf("Inside main() of program not using JrDebug.\n");
	#endif

	// test of some jrdebug statements
    #ifndef NotUsingJrDebugSystem
      // debug output test
	  debugout << "This is a test of debugout stream.";
	  dbprintf("This is a debug printf.");
	#endif

	// all done
	return 0;
}
//---------------------------------------------------------------------------
