//---------------------------------------------------------------------------
// jrdebug_main.cpp
//  8/6/04
// support for debugging stuff
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// NOTE: YOU SHOULD INCLUDE THIS FILE *ONCE* AND ONLY ONCE FROM YOUR MAIN APP
//       (either add it to your project OR #include it from *one* source file).
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// header guards
#ifdef INC_jrdebug_mainh
  // fatal error - this file should only ever be included once
  JRDEBUG_ERROR_This_error_is_triggered_because_you_are_including_jrdebug_main_multiple_times
#endif
#ifndef INC_jrdebug_mainh
#define INC_jrdebug_mainh
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// include main debug header
#include "jrdebug.h"
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
#ifdef JrDebugDIRECTIVE_UseNameSpaces
 // namespaces if you like to use them (see end of file for automatic using statemen)
 namespace jrdebug {
#endif
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// we skip all this if not compiling in debugging
#ifdef JrDebugDIRECTIVE_DontCompileDebugging
//---------------------------------------------------------------------------


	//---------------------------------------------------------------------------
	// This code is compiled in if debug output is turned off
	//---------------------------------------------------------------------------

	//---------------------------------------------------------------------------
	// a fake stream swallower needed to fake the consumption of 'debugout <<' like lines
	MyNullStreamT JrDebugStreamSwallower;
	//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
#else
//---------------------------------------------------------------------------


	//---------------------------------------------------------------------------
	// This code is compiled in if debug output is enabled
	//---------------------------------------------------------------------------

	// one-time includes
	#include "jrdebug_core.h"
	#include "jrdebug_commandline.h"
	#include "jrdebug_output.h"
	#include "jrdebug_output_formatters.h"
	#include "jrdebug_blockhelpers.h"
	#include "jrdebug_unittesting.h"

	// pointer to a global instance (not created if debuggin not compiled in)
	JrDebug* GlobalJrDebugp=NULL;

	// Declare and Initialize statics
	// ATTN: The initializations that used to be here *should* no longer be needed, as they are found in singleton initializer
	//  but i'm leaving them here commented out in case we have troubles later.
	long JrDebug::debugindex;
	jrd_stdstringT JrDebug::currentactivitystring;
	long JrDebug::runid;
	//
	int JrDebug::filtermin;
	bool JrDebug::filter_onlyerrors;
	bool JrDebug::filter_showallblocks;
	//
	bool JrDebug::displaypassingasserts;
	int JrDebug::alarmfilterlevel;
	int JrDebug::exceptionlevel;
	// activity/debug blocks
	JrDebugBlockObjectData* JrDebug::lastblockobjp;
	int JrDebug::debugblockdepth;
	// misc
	JrDebugCallback* JrDebug::jrcallbackp;
	jrd_stdstringT JrDebug::defaultoutputoptions;
	jrd_stdstringT JrDebug::programdescription;
	// testing stuff
	JrDebugRegisteredTestObj* JrDebug::testobjects;
	JrDebugRegisteredTestObj* JrDebug::curtestobjp;
	JrDebugRegisteredTestObj* JrDebug::lasttestobjp;
	bool JrDebug::rantests;//=false;
	// output formats
	JrDebugRegisteredOutputFormatter* JrDebug::formatters;
	JrDebugRegisteredOutputFormatter* JrDebug::lastformatterp;
	JrDebugRegisteredOutputFormatter* JrDebug::formatter_factorys;
	JrDebugRegisteredOutputFormatter* JrDebug::lastformatter_factoryp;
	// startup style
	bool JrDebug::enabled;
	// win32 console redirection
	bool JrDebug::did_checkwin32console=false;
	bool JrDebug::did_allocwin32console=false;

	// instantiate a single global instance (needed so that we can get a destructor called on exit to close any open file)
	JrDebugSingletonInsurer dummysingleton;
	//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// endif for compiled in debugging
#endif
//---------------------------------------------------------------------------










//---------------------------------------------------------------------------
// end of namespace jrdebug
#ifdef JrDebugDIRECTIVE_UseNameSpaces
 };
 // should the namespace automatically visible by anyone who includes this file?
 #ifdef JrdUseNameSpacesAutoUsing
  using namespace jrdebug;
 #endif
#endif
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// endif for header guard
#endif
//---------------------------------------------------------------------------
